/* ==================================================================*/
/*                                                                   */
/* CORE LOGIC                                                        */
/* (c) 2015 - 2016 Yves Sorge Verlag & Neue Medien                   */
/*                                                                   */
/* ==================================================================*/


/* LAYOUT FUNCTIONS */
/* ------------------------------------------------------------------*/

function AppLayoutClass(){
	
	this.resizeTopBar = function(){
		var height = $("#TopNavigation").height();
		$("#Container").css("padding-top", height+"px");
	}

}
var AppLayout = new AppLayoutClass;


/* SYSTEM FUNCTIONS */
/* ------------------------------------------------------------------*/
	
function SystemFunctionClass(){

	this.exitApp = function(){
		if(navigator.app){
			navigator.app.exitApp();
		} else if(navigator.device){
			navigator.device.exitApp();
		}
	}

	this.loadUrl = function(id){
		var url = $("#"+id).attr("rel");
		if (isIos()) {
			window.open(url, '_system');
		} else if (navigator.app && navigator.app.loadUrl) {
			navigator.app.loadUrl(url, { openExternal: true });
		} else {
			window.open(url, "_system", "location=yes");
		}
		return false;
	} 
		
}
var SystemFunction = new SystemFunctionClass;


/* AD HANDLER */
/* ------------------------------------------------------------------*/

var adhandlerInterstitialShowed = 0;
var adhandlerMinTimeElapsed = false;
var adhandlerCountedEnforcements = 0;
function AdHandlerClass() {
	
	this.init = function(){
		try {
			if (AdMob && admobid.banner != "" 
					&& Settings.getSystemFlag("hideAds") == false
					&& hideAds == false
					&& Counter.getStartCount() > 2) {
				// Load advertisement banner after 4 seconds 
				// due to performance feeling on startup.
				window.setTimeout(function(){
					AdMob.createBanner({
						adId : admobid.banner,
						position : AdMob.AD_POSITION.BOTTOM_CENTER,
						autoShow : true,
						adSize   : 'SMART_BANNER',
						overlap  : false,
					});
				}, 4000);
				// Load interstitial in background after 8 seconds 
				// due to performance feeling on startup.
				window.setTimeout(function(){
					AdMob.prepareInterstitial( 
						{adId:admobid.interstitial, 
						autoShow:false} 
					);
				}, 8000);
				// Trigger interstitial enforcement by time after
				// 15 seconds.
				window.setTimeout(function(){
					adhandlerMinTimeElapsed = true;
					AdHandler.enforceInterstitialByTime();
				}, 15000);
			}
		} catch (err){
			alertErr(err);
		}
	}
	
	this.showInterstitial = function(){
		try {
			adhandlerInterstitialShowed++;
			AdMob.showInterstitial();
		} catch (err){
			alertErr(err);
		}
	}
	
	this.enforceInterstitialByTime = function(){
		try {
			if (AdMob && admobid.banner != "" 
					&& Settings.getSystemFlag("hideAds") == false 
					&& hideAds == false) {
				// BY TIME
				if (Counter.getStartCount() > 2 
						&& Counter.getStartCount() < 9
						/*&& Counter.getStartCount() % 2 == 1*/
						&& adhandlerMinTimeElapsed
						&& adhandlerInterstitialShowed < 1){
					this.showInterstitial();
				} 
				if (Counter.getStartCount() > 10 
						&& Counter.getStartCount() % 5 == 0
						&& adhandlerMinTimeElapsed
						&& adhandlerInterstitialShowed < 1){
					this.showInterstitial();
				} 
			}
		} catch (err){
			alertErr(err);
		}
	}
	
	this.enforceInterstitial = function(){
		try {
			adhandlerCountedEnforcements++;
			if (AdMob && admobid.banner != "" 
					&& Settings.getSystemFlag("hideAds") == false 
					&& hideAds == false
					&& adhandlerInterstitialShowed < 1
					&& Counter.getStartCount() > 2) {
				// BY SCREENS
				if (Counter.getStartCount() % 2 == 0 
						&& adhandlerCountedEnforcements > 4){
					this.showInterstitial();
				} else if (Counter.getStartCount() % 2 == 1 
						&& adhandlerCountedEnforcements > 7){
					this.showInterstitial();
				}
			}
		} catch (err){
			alertErr(err);
		}
	}
}
var AdHandler = new AdHandlerClass;


/* SCREEN MANAGER */
/* ------------------------------------------------------------------*/

function ScreenManagerClass(){
	
	this.showScreen = function(screenId){
		screenId = "Screen"+screenId;
		Navigation.hide();
		AdHandler.enforceInterstitial();
		$("#"+currentScreen).hide();
		$("#"+screenId).show();
		lastScreen = currentScreen;
		currentScreen = screenId;
		window.scrollTo(0,0);
	}

	this.showLockedScreen = function(){
		$("#LockedScreen").fadeIn();
	}
	
	this.hideLockedScreen = function(){
		$("#LockedScreen").fadeOut();
	}

	this.loaderStart = function(){
		if (!Settings.get("hideLoader")){
			$("#Loader").fadeIn();
		}
	}
	
	this.loaderStop = function(){
		$("#Loader").fadeOut();
	}

	this.goBack = function(){
		if (isNavigationVisible){
			Navigation.toggle();
		} else {
			if (currentScreen == "ScreenHolidaysDetail") {
				ScreenManager.showScreen("Holidays");
				return false;
			} else if (currentScreen == "ScreenCategory" &&
					lastScreen == "ScreenDetail") {
				ScreenManager.showScreen("Detail");
				return false;
			} else if (currentScreen != "ScreenOverview"){
				ScreenManager.showScreen("Overview");
				return false;	
			} else {
				SystemFunction.exitApp();
				return true;
			}
		}
	}
	
}
var ScreenManager = new ScreenManagerClass;


/* NAVIGATION */
/* ------------------------------------------------------------------*/

var isNavigationVisible = false;
function NavigationClass(){
	
	this.toggle = function(){
		AppLayout.resizeTopBar();
		if ($("#Navigation").css("display") == "none"){
			$("#Navigation").slideDown(300);
			ScreenManager.showLockedScreen();
			isNavigationVisible = true;
		} else {
			this.hide();
			isNavigationVisible = false;
		}
		
	}
	
	this.hide = function(){
		if ($("#Navigation").css("display") != "none"){
			$("#Navigation").slideUp(300);
			ScreenManager.hideLockedScreen();
			isNavigationVisible = false;
		}
	}
	
}
var Navigation = new NavigationClass;


/* EVENT DETAIL */
/* ------------------------------------------------------------------*/

var currentEvent = {};

function DetailClass(){

	this.clearView = function(){
		$("#DetailTitle").empty();
		$("#DetailText").empty();
		$("#DetailImageContainer").hide();
		$("#DetailImage").attr("rel", "");
		$("#DetailMoreButton").hide();
		//$("#DetailMoreButton2").hide();
		$("#DetailShareButton").attr("shareLink", "");
		$("#DetailShareButton").attr("shareTitle", "");
		$("#DetailShareButton").attr("shareMessage", "");
		$("#DetailShareButton").hide();
		currentEvent = {};
	}
	
	this.gotoByElementId = function(id){
		var eventId = $("#"+id).attr("rel");
		if (eventId && eventId != ""){
			return this.gotoByDatestring(eventId);
		}
		return false;
	}
	
	this.gotoByDatestring = function(id){
		ScreenManager.loaderStart();
		Navigation.hide();
		Detail.clearView();
		if (testmode){
			var result = TestData.getDetail();
			if (ServerResponse.withErrorMessage(result)){
				ServerResponse.handleErrorMessage(result);
			} else {
				Detail.updateData(result);
				ScreenManager.showScreen("Detail");
			}
			ScreenManager.loaderStop();
		} else {
			$.post(strings.baseUrl+"rest/event-info/3.0/?id="+id,
					ServerRequest.createRequestHeader(), function(result){
				if (ServerResponse.withErrorMessage(result)){
					ServerResponse.handleErrorMessage(result);
				} else {
					Detail.updateData(result);
					ScreenManager.showScreen("Detail");
				}
			}, "json").fail(function() {
				Tools.showErrorMessage(
					strings.errorTitle, 
					strings.errorLoadEventDetails
				);
			}).always(function() {;
				ScreenManager.loaderStop();
			});
		}
	}	
	
	this.updateData = function(result){
		if (result != null && (result.response || null) != null){
			var data = result.response;
			currentEvent = data;
			$("#DetailTitle").empty().append(data.title);
			$("#DetailText").empty().append(data.text);
			if (data.sharing != null){
				DataSetter.setSharingData(data.sharing, "DetailShareButton");
			}
			if (data.moreLink != null && data.moreLink != ''){
				$("#DetailMoreButton").show();
				//$("#DetailMoreButton2").show();
				$("#DetailMoreButton").attr("rel", data.moreLink);
				//$("#DetailMoreButton2").attr("rel", data.moreLink);
			} else {
				$("#DetailMoreButton").hide();
				//$("#DetailMoreButton2").hide();
			}
			if ((data.category || null) != null){
				$("#DetailCategoryButton").show();
				$("#DetailCategoryButton").text(
					strings.category + ": " + data.category.title
				);
				$("#DetailCategoryButton").attr("rel", data.category.id);
			} else {
				$("#DetailCategoryButton").hide();
			}
			if (data.image.url != null && data.image.url != '' && !Settings.get("hideImages")){
		    	$("#DetailImageContainer").show();
		    	$("#DetailImage").attr("src", data.image.url);
				if (data.image.caption != null){
					$("#DetailImageCaption").empty().append(data.image.caption);
				} else {
					$("#DetailImageCaption").empty();
				}
				if (data.image.copyright != null){
					$("#DetailImageCopyright").empty().append(data.image.copyright);
				} else {
					$("#DetailImageCopyright").empty();
				}
				if (data.subtitle != null){
					$("#DetailSubtitle").empty().append(data.subtitle);
					$("#DetailSubtitle").show();
				} else {
					$("#DetailSubtitle").empty();
					$("#DetailSubtitle").hide();
				}
				$("#DetailTextContainer").removeClass("medium-12 large-12");
				$("#DetailTextContainer").addClass("medium-6 large-6");
				$("#DetailTextContainer").addClass("padding-right-30");
				$("#DetailImageContainer").removeClass("medium-12 large-12");
				$("#DetailImageContainer").addClass("medium-6 large-6");
		    } else {
				$("#DetailTextContainer").removeClass("medium-6 large-6");
				$("#DetailTextContainer").addClass("medium-12 large-12");
				$("#DetailTextContainer").removeClass("padding-right-30");
				$("#DetailImageContainer").hide();
				$("#DetailImageContainer").removeClass("medium-6 large-6");
				$("#DetailImageContainer").addClass("medium-12 large-12");
		    }
	    }
	}	
	
}
var Detail = new DetailClass;


/* CONTENT FILTER */
/* ------------------------------------------------------------------*/

function ContentFilterClass(){
	
	this.isShowable = function(filterClass, isAdditional){
		if (filterClass){
			if (isAdditional == "true" || isAdditional == "1"){
				if (filterClass == "TheatricalRelease"){
					if (Settings.get("showTheatricalReleases") && proMode){
						return true;
					} else {
						return false;
					}
				}
				if (filterClass == "ConcertFestival"){
					if (Settings.get("showConcertsFestivals") && proMode){
						return true;
					} else {
						return false;
					}
				}
				if (filterClass == "FairCongress"){
					if (Settings.get("showFairsCongresses") && proMode){
						return true;
					} else {
						return false;
					}
				}
				if (filterClass == "FolkFestival"){
					if (Settings.get("showFolkFestivals") && proMode){
						return true;
					} else {
						return false;
					}
				}
				if (filterClass == "MassEvents" && proMode){
					if (Settings.get("showMassEvents")){
						return true;
					} else {
						return false;
					}
				}
			}
		}
		return true;
	}
}
var ContentFilter = new ContentFilterClass;


/* EVENT OVERVIEW */
/* ------------------------------------------------------------------*/

function OverviewClass(){
	
	this.clearView = function(){
		$("#EventReloader").hide();
		$("#OverviewYesterday").attr("dateVal","");	
		$("#OverviewTomorrow").attr("dateVal","");
		$("#OverviewEventListEntries").empty().append(
			"<li class='tapEvent' id='HintNoEventsAvailable'>("+strings.noEventsAvailable+")</li>"
		);
		$("#OverviewImageContainer").hide();
		$("#OverviewImage").attr("src", "images/placeholder.png");
		$("#OverviewImage").attr("rel", "");
		$("#OverviewDayname").empty();
		var d = new Date();
		var datestring = Tools.twoDigit(d.getDate()) + "." + 
			Tools.twoDigit((d.getMonth()+1)) + "." + d.getFullYear();
		if (lang == "en"){
			datestring = Tools.twoDigit((d.getMonth()+1)) + "/"+ 
				Tools.twoDigit(d.getDate()) + "/" + d.getFullYear();
		}
		$("#OverviewDate").empty().append(datestring);
		$("#OverviewDayInfo").hide();
		$("#OverviewDayInfoContent").html("");
	}
	
	this.swipeLeft = function(){
		Overview.gotoById("OverviewTomorrow");
	}

	this.swipeRight = function(){
		Overview.gotoById("OverviewYesterday");
	}	
    
	this.gotoById = function(id){
		this.gotoByDatestring( $("#"+id).attr("dateVal") );
	}

	this.show = function(){
		Navigation.hide();
		ScreenManager.showScreen("Overview");
	}
	
	this.gotoByDatestring = function(dateVal){
		ScreenManager.loaderStart();
		this.show();
		$.post(strings.baseUrl+"rest/event-overview/3.0/?date="+dateVal, 
				ServerRequest.createRequestHeader(), function(result){
			if (ServerResponse.withErrorMessage(result)){
				ServerResponse.handleErrorMessage(result);
			} else {
				var data = (result.response || null);
				Overview.updateData(data);
			}
		}, "json").fail(function() {
			Tools.showErrorMessage(strings.errorTitle, strings.errorLoadDateEvents);
		}).always(function() {
			ScreenManager.loaderStop();
		});
		try {
			var splits = dateVal.split("-");
			var d = new Date(
					parseInt(splits[0]),parseInt(splits[1])-1,
					parseInt(splits[2]), 0, 0, 0, 0
				);
			if (Tools.dateAsIsoString(d) == dateVal){
				DatePicker.setDate(d);
			}
		} catch (err){ alertErr(err); }
	}	
	
	this.loadData = function(){
		/*if (navigator.connection != null && Connection != null && navigator.connection.type == Connection.NONE){
			Tools.showErrorMessage(strings.errorNoNetwork);		
		} else {
		if (!navigator.onLine){
			Tools.showErrorMessage(strings.errorTitle, strings.errorNoNetwork);
		} else {*/
		try {
			ScreenManager.loaderStart();
			Overview.clearView();
			
			var key = "overview-"+lang;
			if (RequestCache.exists(key, 600)){
				var data = RequestCache.get(key);
				Overview.updateData(data);
				ScreenManager.loaderStop();
				AdHandler.init();
			} else if (testmode){
				
				var result = TestData.getOverview();

				if (result == null){
					Tools.showErrorMessage(strings.errorTitle, strings.errorCorruptedData);
				} else {
					if (ServerResponse.withErrorMessage(result)){
						ServerResponse.handleErrorMessage(result);
					} else {
						var data = (result.response || null);
						if (data != null){
							Overview.updateData(data);
							RequestCache.set(key, data);
						} else {
							Overview.clearView();
							// TODO What is this for a situation?
						}
					}
					ServerResponse.checkAndShowNotifications(result);
					ServerResponse.checkSystemFlags(result);
				}
				ScreenManager.loaderStop();
			} else {
				$.post(strings.baseUrl+"rest/event-overview/3.0/", 
						ServerRequest.createRequestHeader(), function(result){
					if (result == null){
						Tools.showErrorMessage(strings.errorTitle, strings.errorCorruptedData);
					} else {
						if (ServerResponse.withErrorMessage(result)){
							ServerResponse.handleErrorMessage(result);
						} else {
							var data = (result.response || null);
							Overview.updateData(data);
							RequestCache.set(key, data);
						}
						ServerResponse.checkAndShowNotifications(result);
						ServerResponse.checkSystemFlags(result);
					}
				}, "json").done(function() {
					//((console.log( "second success" );
				}).fail(function() {
					//console.log( "Error: Can't load overview data for current day." );
					Tools.showErrorMessage(strings.errorTitle, strings.errorLoadCurrentEvents);
					$("#EventReloader").fadeIn();
					$("#HintNoEventsAvailable").fadeOut();
				}).always(function() {
					//console.log( "complete" );
					ScreenManager.loaderStop();
					AdHandler.init();
				});
			}
		} catch (err){ alertErr(err); }
	}           
    
    this.updateData = function(response){
    	if (response != null){
    		Overview.clearView();
			var image = (response.image || null);
	    	if (image && image.url && !Settings.get("hideImages")){
				$("#OverviewImage").attr("src", "images/placeholder.png");
				$("#OverviewImageContainer").show();
				$("#OverviewImage").attr("src", image.url);
				$("#OverviewImage").attr("rel", "");
				if (image.eventDetailsAvailable && 
						image.eventDetailsAvailable == "1" && image.eventId){
					$("#OverviewImage").attr("rel", image.eventId);
				}
	    	} else {
	    		$("#OverviewImageContainer").hide();
	    	}
	    	
	    	var date = (response.date || null);
	    	if (date){
	    		var datestring = Tools.twoDigit(date.day) + "." + 
	    			Tools.twoDigit(date.month) + "." + date.year;
	    		if (lang == "en"){
	    			datestring = Tools.twoDigit(date.month) + "/" + 
	    				Tools.twoDigit(date.day) + "/" + date.year;
	    		}
		    	$("#OverviewDate").empty().append(
		    		datestring
		    	);
		    	$("#OverviewDayname").empty().append(date.dayname+", ");

		    	if (date.prev != null && date.prev.daycode != null){
		    		$("#OverviewYesterday").attr("dateVal",date.prev.daycode);
		    		// $("#OverviewYesterday").show();
		    		$("#OverviewYesterdayNavArrow").attr("src", "images/right.png");
		    	} else {
					$("#OverviewYesterday").attr("dateVal", "");
					//$("#OverviewYesterday").hide();
					$("#OverviewYesterdayNavArrow").attr("src", "images/empty-arrow.png");
		    	}

		    	if (date.next != null && date.next.daycode != null){
		    		$("#OverviewTomorrow").attr("dateVal",date.next.daycode);
		    		$("#OverviewYesterdayNavArrow").attr("src", "images/left.png");
		    	} else {
		    		$("#OverviewTomorrow").attr("dateVal","");
		    		$("#OverviewYesterdayNavArrow").attr("src", "images/empty-arrow.png");
		    	}
	    	}

	    	var events = (response.events || null);
	    	if (events){
	    		$("#OverviewEventListEntries").empty();
			  	$.each(events, function(i, field) {
			  		if (ContentFilter.isShowable(field.filterClass, field.isAdditional)){
				   		if (field.detailsAvailable != null && field.detailsAvailable == "1"){
				  			$("#OverviewEventListEntries").append( 
				  				"<li class='tapEvent moreArrow' onclick='Detail.gotoByDatestring("+field.id+")'>"+
				  				field.title+"</li>" 
				  			);
				   		} else {
				   			$("#OverviewEventListEntries").append( 
				   				"<li class='tapEvent' onclick=\"Tools.showMessage(null, '"+
				   				strings.noDetailInfo+"')\">"+field.title+"</li>"
				   			);
				   		}
			  		}
			   	});
	    	}
	    	
	    	var dayinfo = Overview.getDayInfoAsHtml(response);
	    	if (dayinfo != null){
	    		$("#OverviewDayInfo").show();
	    		$("#OverviewDayInfoContent").html( dayinfo );
	    	}
	    	
	    	if (this.updateExhancedData){
	    		this.updateExhancedData(response);
	    	}
    	} 	
    }    
	
	this.getDayInfoAsHtml = function(response){
		var data = null;
		if (response){
			data = "";		

			if (response.namedays){
				data += '<div class="overviewEntry">';
				data += '<b>'+strings.infoNameDays+'</b><br>';	
				data += response.namedays+'</div>';	
			}
			
			if (response.date && response.info){
				data += '<div class="overviewEntry">';
				data += '<b>'+strings.infoAboutDay+'</b><br>';
				data += Tools.numeration(response.date.week)+' '+strings.infoCalendarWeek+'<br>';
				data += Tools.numeration(response.date.daynumber)+' '+strings.infoDayOfTheYear+'<br>';
				data += response.countdown.nextYear.days+' '+strings.infoDaysLeft+'<br>';
				data += strings.infoMonth+": "+response.date.monthname+"<br>";
				data += strings.infoWeekday+": "+response.date.dayname+"<br>";
				data += strings.infoZodiacSign+': '+response.info.zodiac.label;
				data += '</div>';
			}
			if (response.calendar && response.calendar.islamic){
				data += '<div class="overviewEntry">';
				data += '<b>'+strings.infoIslamicCalendar+'</b><br>';
				data += Tools.dateAsString(
						response.calendar.islamic.year,
						response.calendar.islamic.monthname,
						response.calendar.islamic.day)+'</div>';
			}

			if (response.calendar && response.calendar.jewish){
				data += '<div class="overviewEntry">';
				data += '<b>'+strings.infoJewishCalendar+'</b><br>';
				data += Tools.dateAsString(
						response.calendar.jewish.year,
						response.calendar.jewish.monthname,
						response.calendar.jewish.day)+'</div>';
			}

			if (response.info && response.info.sun){
				var sun = response.info.sun[0]; 
				data += '<div class="overviewEntry">';
				data += '<b>'+strings.infoSunPath+'</b><br>';
				data += strings.infoSunrise+': '+Tools.timeAsString(sun.sunrise.hour, sun.sunrise.minute)+'<br>';
				data += strings.infoSunset+': '+Tools.timeAsString(sun.sunset.hour, sun.sunset.minute)+'<br>';
				data += strings.infoSunForPlace+' '+sun.place+' ('+sun.countrycode+')';
				data += '</div>';
			}
			
			if (this.getDayInfoAsHtmlExtended){
				data = this.getDayInfoAsHtmlExtended(data, response);
			}
			
		}
		return data;
	}

}
var Overview = new OverviewClass;


/* CATEGORY */
/* ------------------------------------------------------------------*/

function CategoryClass() {

	this.gotoByElementId = function(id){
		var objectId = $("#"+id).attr("rel");
		if (objectId && objectId != ""){
			return this.gotoById(objectId);
		}
		return false;
	}

	this.gotoById = function(id){
		ScreenManager.loaderStart();
		Navigation.hide();
		this.clearView();
		if (testmode){
			var result = TestData.getCategory();
			if (ServerResponse.withErrorMessage(result)){
				ServerResponse.handleErrorMessage(result);
			} else {
				this.updateView(result);
				ScreenManager.showScreen("Category");
			}
			ScreenManager.loaderStop();
		} else {
			$.post(strings.baseUrl+"rest/category-detail/2.0/?id="+id,
					ServerRequest.createRequestHeader(), function(result){
				if (ServerResponse.withErrorMessage(result)){
					ServerResponse.handleErrorMessage(result);
				} else {
					Category.updateView(result);
					ScreenManager.showScreen("Category");
				}
			}, "json").fail(function() {
				Tools.showErrorMessage(strings.errorTitle, strings.errorLoadEventDetails);
			}).always(function() {;
				ScreenManager.loaderStop();
			});
		}
	}

	this.clearView = function(){
		$("#CategoryTitle").text("");	
		$("#CategoryEventListEntries").empty().append( 
			"<li class='tapEvent'>("+strings.noEventsAvailable+")</li>"
		);
		$("#CategoryImageContainer").hide();
		$("#CategoryImage").attr("src", "images/placeholder.png");
		$("#CategoryImage").attr("rel", "");
		$("#CategoryMoreButton").attr("rel","");
		$("#CategoryMoreButton").hide();
		$("#CategoryShareButton").attr("shareLink", "");
		$("#CategoryShareButton").attr("shareTitle", "");
		$("#CategoryShareButton").attr("shareMessage", "");
		$("#CategoryShareButton").hide();
	}

	this.updateView = function(result){
		if (result != null && (result.response || null) != null){
		    	var data = result.response;
			$("#CategoryTitle").text(strings.category + ": "+ data.title);
			if (data.sharing != null){
				DataSetter.setSharingData(data.sharing, "CategoryShareButton");
			}
			var events = (data.events || null);
			if (events){
			    	$("#CategoryEventListEntries").empty();
			    	$.each(events, function(i, field) {
					try {
					var date = field.date;
					var datestring = Tools.twoDigit(date.day) + "." + 
						Tools.twoDigit(date.month) + "." + 
						(""+date.year).substr(2,2);
					if (lang == "en"){
						datestring = Tools.twoDigit(date.month) + "/" + 
							Tools.twoDigit(date.day) + "/" + 
							(""+date.year).substr(2,2);
					}
					datestring = " &ndash; "+datestring+"";
			    		if (field.detailsAvailable != null && field.detailsAvailable == "1"){
			    			$("#CategoryEventListEntries").append( "<li class='tapEvent moreArrow' onclick='Detail.gotoByDatestring("+field.id+")'>"+field.title+datestring+"</li>" );
			    		} else {
			    			$("#CategoryEventListEntries").append( "<li class='tapEvent' onclick=\"Tools.showMessage(null, '"+strings.noDetailInfo+"')\">"+field.title+datestring+"</li>" );
			    		}
				       } catch (err){
					alertErr(err);
				       }
			    	});
			}
			if (data.moreLink != null && data.moreLink != ''){
		    		$("#CategoryMoreButton").show();
		    		$("#CategoryMoreButton").attr("rel", data.moreLink);
		    	} else {
		    		$("#CategoryMoreButton").hide();
		    	}
		}
	}

}
var Category = new CategoryClass;



/* DATA SETTER HELP CLASS */
/* ------------------------------------------------------------------*/

function DataSetterClass() {
	
	this.setSharingData = function(sharing, buttonId){
		try {
			if (sharing != null){
				var sharingExists = false;
				if (sharing.link){
					$("#"+buttonId).attr("shareLink", sharing.link);
					sharingExists = true;
				} else {
					$("#"+buttonId).attr("shareLink", "");
				}
				if (sharing.title){
					$("#"+buttonId).attr("shareTitle", sharing.title);
					sharingExists = true;
				} else {
					$("#"+buttonId).attr("shareTitle", "");
				}	
				if (sharing.message){
					$("#"+buttonId).attr("shareMessage", sharing.message);
					sharingExists = true;
				} else {
					$("#"+buttonId).attr("shareMessage", "");
				}
				if (sharingExists){
					$("#"+buttonId).show();
				} else {
					$("#"+buttonId).hide();
				}
			} else {
				$("#"+buttonId).hide();
			}
		} catch (err){ alertErr(err); }
	}
	
}
var DataSetter = new DataSetterClass;


/* CACHE */
/* ------------------------------------------------------------------*/

function RequestCacheClass() {

	this.createEntryKey = function(key){
		return "centry-"+encodeURIComponent(key);
	}
	this.createDateKey = function(key){
		return "cdate-"+encodeURIComponent(key);
	}
	this.createIdKey = function(key){
		return encodeURIComponent(key);
	}
	this.exists = function(id, lifetime){
		var entryKey = this.createEntryKey(id);
		var dateKey = this.createDateKey(id);

		var d = new Date();
		var ts = Math.round(d.getTime() / 1000);
		var cdate = localStorage.getItem(dateKey);

		if (cdate > 0 && Math.abs(ts - cdate) < lifetime){
			if (localStorage.getItem(entryKey)){
				return true;
			}
		}
		return false;
	}

	this.set = function(id, value){
		var entryKey = this.createEntryKey(id);
		var dateKey = this.createDateKey(id);
		var idKey = this.createIdKey(id);
		
		var entryValue = JSON.stringify(value);
		var d = new Date();
		var dateValue = Math.round(d.getTime() / 1000);

		localStorage.setItem(entryKey, entryValue);
		localStorage.setItem(dateKey, dateValue);

		var createNewListEntry = true;
		var clistRaw = localStorage.getItem("clist");
		if (clistRaw){
			var clist = JSON.parse(clistRaw);
			if (!clist){
				clist = {};
			} else {
				for (key in clist){
					if (key == idKey){
						createNewListEntry = false;
						break;
					}
				}
			}
		} else {
			var clist = {};
		}
		if (createNewListEntry){
			clist[idKey] = 1;
			localStorage.setItem("clist", JSON.stringify(clist));
		}
	}

	this.get = function(key){
		key = this.createEntryKey(key);
		var cachedData = localStorage.getItem(key);
		if (cachedData){
			var data = JSON.parse(cachedData);
			return data;
		}
		return null;
	}

	this.optimize = function(){
		var clistRaw = localStorage.getItem("clist");
		if (clistRaw){
			var clist = JSON.parse(clistRaw);
			if (!clist){
				createNewListEntry = true;
				clist = {};
			} else {
				var id = null;
				var cacheTs = null;
				var d = new Date();
				var ts = Math.round(d.getTime() / 1000);
				var newClist = {};
				for (key in clist){
					id = key;
					cacheTs = localStorage.getItem("cdate-"+id);
					// Max lifetime are 10 days
					if (Math.abs(ts - cacheTs) > 864000){
						localStorage.removeItem("centry-"+id);
						localStorage.removeItem("cdate-"+id);
					} else {
						newClist[key] = 1;
					}
				}
				localStorage.setItem("clist", JSON.stringify(newClist));
			}
		}
	}
}
var RequestCache = new RequestCacheClass;


/* SERVER REQUEST */
/* ------------------------------------------------------------------*/

function ServerRequestClass() {

	this.createRequestHeader = function(){
		if (window.device != null){
			var uuidRaw  = 	window.device.uuid;
			var hash1 = CryptoJS.MD5(uuidRaw + "sugar");
			var hash2 = CryptoJS.MD5(uuidRaw + "pepper");
			if (hash2){
				hash2 = (hash2+"").substr(0,4);
			}
			var uuidHash = hash1 + hash2 + "";
			var pwdPre = "";
			var pwdPost = "";
			if (uuidHash && uuidHash.length > 5){
				pwdPre = uuidHash.slice(-4);
				pwdPost = uuidHash.substr(0,4);
			}

			startCount = (Counter.getStartCount() || 0 );

			var payload = {
				authentication: {
					user: "Guest001",
					password: (pwdPre + "3qRsgfhyZx" + pwdPost),
				},
				device: {
					uuid: uuidHash,
					platform: window.device.platform,
					version: window.device.version,
					model: window.device.model,
				},
				app: {
					version: appInfo.version,
					id: appInfo.id,
					starts: startCount,
					proMode: proMode,
				},
				screen: {
					width: window.screen.width,
					height: window.screen.height,
					availWidth: window.screen.availWidth,
					availHeight: window.screen.availHeight,
					colorDepth: window.screen.colorDepth,
					pixelDepth: screen.pixelDepth,
					orientation: window.orientation,
				},
				language: {
					current: lang,
					prefered: prefLang,
				},
			};
			var requestMsgRaw = JSON.stringify(payload);
			return {
				request: requestMsgRaw
			};
		}
		return { };
	}
}
var ServerRequest = new ServerRequestClass;


/* SERVER RESPONSE */
/* ------------------------------------------------------------------*/

function ServerResponseClass() {

	this.handleErrorMessage = function(result){
		if (result != null && (result.header || null) != null){
			var error = (result.header.error || null);
			if (error != null && error.title && error.text){
				Tools.showErrorMessage(error.title, error.text);
			}
		}
	}

	this.withErrorMessage = function(result){
		if (result != null && (result.header || null) != null){
			var error = (result.header.error || null);
			if (error != null && error.title){
				return true;
			}
		}
		return false;
	}

	this.checkSystemFlags = function(response){
		var flags = null;
		if (response != null && (response.header || null) != null){
			flags = (response.header.flags || null); 
		}
		if (flags != null){
			if (flags.hideAds){
				Settings.setSystemFlag("hideAds", flags.hideAds);
			}
		}
	}

	this.checkAndShowNotifications = function(response){
		var notification = null;
		if (response != null && (response.header || null) != null){
			notification = (response.header.notification || null);
		}
		if (notification != null){
			var id = (notification.id || null);
			var text = (notification.text || null);
			var title = (notification.title || null);
			if (id != null && text != null){
		  		var key = "msg"+id;
				if (localStorage.getItem(key) == null || localStorage.getItem(key) === undefined){
					localStorage.setItem(key, 1);
					localStorage.setItem("lastNotification", id);
					Tools.showMessage(title, text);
				}
			}
		}
	}
}
var ServerResponse = new ServerResponseClass;


/* SHARER */
/* ------------------------------------------------------------------*/

function SharerClass(){
	
	this.share = function(dataContainerId){
		try {
			var link = $("#"+dataContainerId).attr("shareLink");
			var title = $("#"+dataContainerId).attr("shareTitle");
			var message = $("#"+dataContainerId).attr("shareMessage");
			
			if (link && title && message){
				window.plugins.socialsharing.share(message, title, null, link);
			} else if (link && title){
				window.plugins.socialsharing.share(null, title, null, link);
			} else if (link){
				window.plugins.socialsharing.share(null, null, null, link);
			} else if (message){
				window.plugins.socialsharing.share(message);
			} else {
				Tools.showErrorMessage(
						strings.errorTitle, 
						strings.errorShareNoData
				);
			}
		} catch(e){
			Tools.showErrorMessage(
					strings.errorTitle, 
					strings.errorShareFailed
			);			
		}
	}
	
	
}
var Sharer = new SharerClass;


/* DATE PICKER */
/* ------------------------------------------------------------------*/

var DatePickerConfig = {
	date: new Date(),
	mode: 'date',
	todayText: strings.wordToday,
	locale: 'en_US',
	androidTheme: 5,
	minDate: 0,
	maxDate: 0
};

function DatePickerClass() {

	this.setDate = function(date){
		DatePickerConfig.date = date;
	}
	
	this.onSuccess = function(date) {
		try {
			var datestring = Tools.dateAsIsoString(date);
			var splits = DatePickerConfig.date.split("/");
			var oldDate = new Date(
					parseInt(splits[2]), parseInt(splits[0])-1, 
					parseInt(splits[1]), 12, 0, 0, 0
				);
			if (Tools.dateAsIsoString(oldDate) != datestring){
				DatePickerConfig.date = date;
				Overview.gotoByDatestring(datestring);
			} else {
				DatePickerConfig.date = date;
				Overview.show();
			}
		} catch (e){
			// TODO something meaningful
			console.log(e);
		}
	}
		 
	this.onError = function(error) { // Android only 
		console.log('Error: ' + error);
	}

	this.show = function(){
		var nowDate = new Date();
		DatePickerConfig.minDate = nowDate.getTime() - minDaysOffset;
		DatePickerConfig.maxDate = nowDate.getTime() + maxDaysOffset;
		DatePickerConfig.locale = LanguageHandler.getLocale();
		DatePickerConfig.todayText = strings.wordToday;
		Navigation.hide();
		datePicker.show(DatePickerConfig, this.onSuccess, this.onError);
		// $("#LockedScreen").show();
		// $("#DatePicker").show();
	}

	this.hide = function(){
		$("#LockedScreen").hide();
		$("#DatePicker").hide();
	}

}
var DatePicker = new DatePickerClass;


/* SETTINGS */
/* ------------------------------------------------------------------*/

function SettingsClass() {

	this.getSystemFlag = function(key){
		var value = localStorage.getItem(key);
		if (value && value == 1){
			return true;
		}
		return false;
	}

	this.get = function(key){
		return this.getSystemFlag(key);
	}
	
	this.setSystemFlag = function(key, value){
		if (value == "1" || value == true){
			localStorage.setItem(key, 1);
		} else if (value == "2" || value == false){
			localStorage.setItem(key, null);
			localStorage.removeItem(key);
		}
	}

}
var Settings = new SettingsClass;


/* LANGUAGE */
/* ------------------------------------------------------------------*/

function LanguageHandlerClass(){
	
	this.getLocale = function(){
		locale = "en_US";
		if (lang == "de"){
			locale = "de_DE";
		}
		return locale;
	}
	
}
var LanguageHandler = new LanguageHandlerClass;


/* TOOLS */
/* ------------------------------------------------------------------*/

function ToolsClass() {

	this.showErrorMessage = function(title, message){
		if (!title){
			title = strings.errorTitle;
		}
		this.showMessage(title, message);
	}
	
	this.showDebugMessage = function (message){
		if (debugMode){
			this.showMessage("DEBUG MESSAGE", message);
		}
	}

	this.showMessage = function(title, text){
		if (!title){
			title = strings.noticeTitle;
		}
		if (navigator.notification){
			navigator.notification.alert(
				text,      // message
				null,      // callback
				title,     // title
				"OK"       // buttonName
			);
		} else {
			if (title != null && title != ""){
				text = title+"\n"+text;
			}
			alert(text);
		}
	}

	this.twoDigit = function(num){
		if (num >= 0 && num < 10){
			if ((""+num).length != 2){
				return "0"+num;
			}
		}
		return num;
	}

	this.numeration = function(num){
		var value = num+".";
		if (lang == "en"){
			value = num+"th ";
			if (num % 10 == 1){
				value = num+"st";
			}
			if (num % 10 == 2){
				value = num+"nd";
			}
			if (num % 10 == 3){
				value = num+"rd";
			}
		}
		return value;
	}

	this.dateAsIsoString = function(date){
		try {
			return date.getFullYear()+"-"+
				this.twoDigit(date.getMonth()+1)+"-"+
				this.twoDigit(date.getDate());
		} catch (e){
			return null;
		}
	}
	
	this.timeAsString = function(hour, minute){
		var value = Tools.twoDigit(hour)+":"+Tools.twoDigit(minute)+" "+strings.wordOClock;
		if (lang == "en"){
			value = Tools.twoDigit(hour)+":"+Tools.twoDigit(minute);
		}
		return value;
	}

	this.dateAsString = function(year, monthname, day){
		var value = Tools.numeration(day)+" "+monthname+" "+year;
		if (lang == "en"){
			value = monthname+" "+day+", "+year;
		}
		return value;
	}
}
var Tools = new ToolsClass;


/*function DateToolsClass(){

function getPrevDay(current){
	var day   = current.getDate();
	var month = current.getMonth();
	var year  = current.getFullYear();
    	
	day -= 1;
    	
	return new Date(year, month, day);
}

function getNextDay(current){
	var day   = current.getDate();
	var month = current.getMonth();
	var year  = current.getFullYear();
    	
	day += 1;
    	
	return new Date(year, month, day);
}
}
var DateTools = new DatToolsClass;*/


/*
function registerAdEvents() {
	document.addEventListener('onReceiveAd', function(){});
	document.addEventListener('onFailedToReceiveAd', function(data){});
	document.addEventListener('onPresentAd', function(){});
	document.addEventListener('onDismissAd', function(){ });
	document.addEventListener('onLeaveToAd', function(){ });
	document.addEventListener('onReceiveInterstitialAd', function(){ });
	document.addEventListener('onPresentInterstitialAd', function(){ });
	document.addEventListener('onDismissInterstitialAd', function(){ });
}
*/


