
		// Consistency check
		if (testmode || debugMode || hideAds){
			var hint = "";
			var showHint = false;
			if (testmode){
				hint += "TESTMODE\n";
			} 
			if (debugMode) {
				hint += "DEBUGMODE\n";
			} 
			if (hideAds && !proMode){
				hint += "MODE CONFLICT";
			}
			if (hint.length > 0){
				alert(hint);
			}
		}

		function alertErr(err){
			if (debugMode){
				alert(err);
			}
		}

		function isIos(){
			var value = false;
			try {
				value = device.platform.toUpperCase() === 'IOS';
			} catch (e) { }
			return value;
		}
		function isAndroid(){
			var value = false;
			try {
				value = device.platform.toUpperCase() === 'ANDROID';
			} catch (e) { }
			return value;
		}
		function isFirefoxOs(){
			try {
				if (navigator.userAgent.indexOf('Firefox') > -1 && navigator.userAgent.indexOf("Mobile") > -1) {
					return true;
				} else if (navigator.userAgent.indexOf("Firefox") > -1) {
					return true;
				}
			} catch (e) { }
			return false;
		}

		// Detecting device language
		try {
			if (navigator.language && navigator.language.substr(0,2) == "de"){
				lang = "de";
			}
		} catch (err){ alertErr(err); }

		// Detecting app specific language
		try {
			var storedLang = null;
			if (localStorage){
				storedLang = localStorage.getItem("langCode");
			}
			if (storedLang != null){
				if (storedLang == "de" || storedLang == "en"){
					lang = storedLang;
				}
			}
		} catch (err){ alertErr(err); }

		// Loading language specific properties
		var strings = {};
		try {
			strings = stringSets[lang];
		} catch (err){ alertErr(err); }

		// OnLoad method
		function onLoad() {
			document.addEventListener("deviceready", function (){
				onDeviceReady();
			}, false);
		}
		
		// OnDeviceReady method
		function onDeviceReady() {
			try {
				// Register event listener for system buttons
				document.addEventListener("menubutton", Navigation.toggle, false);
				document.addEventListener("backbutton", ScreenManager.goBack, false);        	
			
				// Internationalization
				navigator.globalization.getPreferredLanguage(
					function (language) {
						prefLang = language.value.substr(0,2);
						var storedLang = localStorage.getItem("langCode");
						if (storedLang == null || prefLang != lang){
							localStorage.setItem("langCode", prefLang)
						}
						if (prefLang != lang){
							if (prefLang == "de" || prefLang == "en"){
								lang = prefLang;
							}
							strings = stringSets[lang];
						}
						updateUiStrings();
						AppLayout.resizeTopBar();
						Overview.loadData();
				    },
				    function () { 
						/* ERROR */
						AppLayout.resizeTopBar();
						Overview.loadData();
					}
				);
	
				// Hide exit menu on if needed
				if (isIos() || isFirefoxOs()){
					$("#NavExit").hide();
				}
	
				// Register swipe events
				$("#SwipeSection").on("swipeleft", Overview.swipeLeft);
		 		$("#SwipeSection").on("swiperight", Overview.swipeRight);
		 		
		 		// Premium hint
		 		if (isIos() || isAndroid()){
		 			if(isIos()){
		 				$("#PremiumVersionButton").attr("rel",strings.proHintUrlIos);
		 			} else {
		 				$("#PremiumVersionButton").attr("rel",strings.proHintUrlAndroid);
		 			}
			 		if (!proMode){
			 			$("#PremiumVersionHint").show();
			 		}
		 		}
			} catch (err){ alertErr(err); }
		}
		
		function updateUiStrings(){
			$("#Logo").attr("src", "images/"+strings.logo);
			$("#NavStart").empty().append(strings.navStart);
			$("#NavAbout").empty().append(strings.navAbout);
			$("#NavDatepicker").empty().append(strings.navDatepicker);
			$("#NavSettings").empty().append(strings.navSettings);
			$("#NavHolidays").empty().append(strings.navHolidays);
			$("#NavExit").empty().append(strings.navExit);
			$("#LoaderText").empty().append(strings.loadData);
			$("#DetailMoreButton").empty().append(strings.moreInfo);
			$("#DetailMoreButton2").empty().append(strings.moreInfo);
			$("#DetailShareButton").empty().append(strings.navShare);
			$(".appName").empty().append(strings.appName);
			if (proMode){
				$("#AboutVersion").empty().append(appInfo.version+" PRO");
			} else {
				$("#AboutVersion").empty().append(appInfo.version);
			}
			$("#AboutMoreText").empty().append(strings.aboutMoreText);
			$("#AboutUrl").attr("rel", strings.aboutUrlHref);	
			$("#AboutNewsletterUrl").attr("rel", strings.aboutUrlNewsletter);
			$("#AboutFacebookUrl").attr("rel", strings.aboutUrlFacebook);
			$("#AboutTwitterUrl").attr("rel", strings.aboutUrlTwitter);
			$("#AboutInstagramUrl").attr("rel", strings.aboutUrlInstagram);
			$("#AboutDonationUrl").attr("rel", strings.aboutUrlDonation);
			$("#AboutDonationUrl").empty().append(strings.aboutTextDonation);
			$("#EventReloader").empty().append(strings.overviewTapToReload);
			$("#DetailBackButton").empty().append(strings.navBack);
			$("#DetailExportButton").empty().append(strings.navExport);
			$("#CategoryShareButton").empty().append(strings.navShare);
			$("#CategoryBackButton").empty().append(strings.navBack);
			$("#CategoryMoreButton").empty().append(strings.moreInfo);
			$("#SettingsTitle").empty().append(strings.navSettings);
			if (!isIos() && !isFirefoxOs()){
				$("#NavExit").show();
			} 
			$("#SettingsTitle").empty().append(strings.settingsTitle);
			$("#SettingsSectionEvents").empty().append(strings.settingsSectionEvents);
			$("#SettingsSectionLookAndFeel").empty().append(strings.settingsSectionLookAndFeel);
			$("#SettingsTheatricalReleases").empty().append(strings.settingsTheatricalReleases);
			$("#SettingsConcertsFestivals").empty().append(strings.settingsConcertsFestivals);
			$("#SettingsFairsCongresses").empty().append(strings.settingsFairsCongresses);
			$("#SettingsFolkFestivals").empty().append(strings.settingsFolkFestivals);
			$("#SettingsNoImages").empty().append(strings.settingsNoImages);
			$("#SettingsNoLoader").empty().append(strings.settingsNoLoader);
			$("#PremiumVersionButton").empty().append(strings.proHintLabel);
		}
		
		function CounterClass(){
			this.countStart = function(){
				var count = localStorage.getItem("startCounter");
				if (count && !isNaN(count)){
					count = parseInt(count) + 1;
				} else {
					count = 1;
				}
				localStorage.setItem("startCounter", count);
			}
			this.getStartCount = function(){
				var count = localStorage.getItem("startCounter");
				if (count){
					return count;
				}
				return 0;
			}
		}
		var Counter = new CounterClass;