

	$("#NavHolidays").show();
	$("#NavSettings").show();
	$("#DetailExportContainer").show();
	// $("#DetailExportButton").css("display", "block");
	$("#DetailShareContainer").removeClass("medium-12 large-12");
	$("#DetailShareContainer").addClass("medium-6 large-6 right");
	

	function SettingsScreenClass(){
	
		this.gotoScreen = function(){
			try {
				ScreenManager.loaderStart();
				Navigation.hide();
				this.updateView();
				ScreenManager.showScreen("Settings");
				ScreenManager.loaderStop();
			} catch (e){
				alertErr(e);
				ScreenManager.loaderStop();
			}
		}
		
		this.toggle = function(key){
			if (Settings.getSystemFlag(key)){
				Settings.setSystemFlag(key, false);
			} else {
				Settings.setSystemFlag(key, true);
			}
			this.updateView();
		}
		
		this.renderOption = function(key){
			if (Settings.getSystemFlag(key)){
				$("#SettingsButton_"+key).prop("checked", true);
			} else {
				$("#SettingsButton_"+key).prop("checked", false);
			}
			/*if (Settings.getSystemFlag(key)){
				$("#SettingsButton_"+key).text("ON");
				$("#SettingsButton_"+key).css("background-color","lime");
			} else {
				$("#SettingsButton_"+key).text("OFF");
				$("#SettingsButton_"+key).css("background-color","");
			}*/
		}
		
		this.updateView = function(){
			this.renderOption("hideImages");
			this.renderOption("hideLoader");
			this.renderOption("showTheatricalReleases");
			this.renderOption("showConcertsFestivals");
			this.renderOption("showFairsCongresses");
			this.renderOption("showFolkFestivals");
			this.renderOption("hideReligiousEvents");
			this.renderOption("hideFunHolidays");
		}
		
	}
	var SettingsScreen = new SettingsScreenClass;
	
	
	/* OVERVIEW ENHANCEMENTS */
	/* ------------------------------------------------------------------*/
	
	function OverviewExhancedClass(){		
		this.getDayInfoAsHtmlExtended = function(existentData, response){
			try {
				var quote = (response.quote || null);
		    	if (quote){
		    		var data = "";
					data += '<div class="overviewEntry">';
					data += '<b>'+strings.infoQuote+'</b><br>';
					data += quote.text;
					if (quote.author){
						data += '<br><i>('+quote.author+')</i>';
					}
					data += '</div>';
					return data+existentData;
		    	} else {
		    		return existentData;
		    	}
			} catch (e){
				
			}
		}
	}
	var OverviewExhanced = new OverviewExhancedClass;
	Overview.getDayInfoAsHtmlExtended = OverviewExhanced.getDayInfoAsHtmlExtended;
	
	
	/* EVENT EXPORTER */
	/* ------------------------------------------------------------------*/

	function ExporterClass(){
		
		this.exportSuccess = function(){
			
		}
		this.exportError = function(){
			Tools.showErrorMessage(strings.errorTitle, strings.errorEventExportFailed);
		}
		this.exportToSyscalendar = function(id){
			try {
				var title, location, notes, startDate, endDate;
				var data = currentEvent;
				if (data){
					title = data.title;
					location = data.place.name;
					if (data.moreLink){
						notes = data.moreLink;
					}
					if (data.startDate){
						var dd = data.startDate.day;
						var mm = data.startDate.month;
						var yy = data.startDate.year;
						var hh = 0;
						var ii = 0;
						if (data.startDate.hour && data.startDate.minute){
							hh = data.startDate.hour;
							ii = data.startDate.minute;
						}
						mm -= 1;
						startDate = new Date(yy, mm, dd, hh, ii, 0, 0);
						
						if (hh == 0){
							//endDate = new Date(yy, mm, dd, 23, 59, 59, 0);
							//dd += 1;
							endDate = new Date(yy, mm, dd, 0, 0, 0, 0);
							if (isIos()){
								endDate.setDate(endDate.getDate() + 1);
							}
						}
									
					}
					if (data.endDate){
						var dd = data.endDate.day;
						var mm = data.endDate.month;
						var yy = data.endDate.year;
						var hh = 0;
						var ii = 0;
						if (data.endDate.hour && data.endDate.minute){
							hh = data.endDate.hour;
							ii = data.endDate.minute;
						}
						mm -= 1;
						endDate = new Date(yy, mm, dd, hh, ii, 0, 0);
					}
					
				} 
				if (title && location && startDate) {
					window.plugins.calendar.createEventInteractively(
						title, location, notes, startDate, endDate, this.exportSuccess, this.exportError
					);
				} else {
					Tools.showErrorMessage(strings.errorTitle, strings.errorEventExportInavlidData);
				}
			} catch(e){
				alertErr(e);
				Tools.showErrorMessage(strings.errorTitle, strings.errorEventExportFailed);
			}
		}
		
	}
	var Exporter = new ExporterClass;
	
	/* HOLIDAYS - OVERVIEW */
	/* ------------------------------------------------------------------*/

	function HolidayOverviewClass(){
		
		this.gotoScreen = function(){
			try {
				ScreenManager.loaderStart();
				Navigation.hide();
				this.clearView();
				if (testmode){
					var result = TestData.getHolidayOverview();
					if (ServerResponse.withErrorMessage(result)){
						ServerResponse.handleErrorMessage(result);
					} else {
						this.updateView(result);
						ScreenManager.showScreen("Holidays");
					}
					ScreenManager.loaderStop();
				} else {
					// TODO do fancy stuff
				}
			} catch (e){
				alertErr(e);
				ScreenManager.loaderStop();
			}
		}
		
		this.clearView = function(){
			$("#HolidaysOverviewEntries").empty();
		}
		
		this.countryIterator = function(countries){
			if (countries){
			  	$.each(countries, function(i, field) {
			  		// 1. Add Country label		  		
			  		$("#HolidaysOverviewEntries").append( 
			  				'<div class="font-size-touchlink tiny-font-size-touchlink" '+
			  				'style="background-color:#8fadd5;color:white;padding:10px;text-align:center;">'+
							field.title+
							'</div>'
			  		);
			  		// 2. Iterate states if available
			   		if (field.states){
			   			$("#HolidaysOverviewEntries").append( 
			   					'<div id="HolidaysOverviewStates_'+i+'" class="holidaysEventList">'+
			   					'<ul class="font-size-touchlink tiny-font-size-touchlink" '+
			   					'id="HolidaysOverviewStatesList_'+i+'"></div>'
			   			);
			  			HolidayOverview.statesIterator(field.states, i);
			   		} 
			   	});
	    	}
		}
		var lastCountryPosition = -1;
		this.statesIterator = function(states, parentId){
			this.lastCountryPosition = parentId;
			if (states){
				$.each(states, function(i, field){
					$("#HolidaysOverviewStatesList_"+HolidayOverview.lastCountryPosition).append( 
							'<li class="moreArrow" rel="'+field.id+'" onclick="HolidayDetail.gotoByElementRef(this)">'+
							field.title+
							'</li>'
			  		);
				});
			}
		}
		
		this.updateView = function(result){
			if (result != null && (result.response || null) != null){
				this.countryIterator(result.response.countries);
			} else {
				// TODO err message?
			}
		}
	}
	var HolidayOverview = new HolidayOverviewClass;
	

	/* HOLIDAYS - DETAIL VIEW */
	/* ------------------------------------------------------------------*/

	function HolidayDetailClass(){
		
		this.gotoByElementId = function(id){
			var objectId = $("#"+id).attr("rel");
			if (objectId && objectId != ""){
				return this.gotoById(objectId);
			}
			return false;
		}

		this.gotoByElementRef = function(ref){
			var objectId = ref.getAttribute("rel");
			if (objectId && objectId != ""){
				return this.gotoById(objectId);
			}
			return false;
		}

		this.gotoById = function(id){
			ScreenManager.loaderStart();
			Navigation.hide();
			this.clearView();
			if (testmode){
				var result = TestData.getHolidayDetail();
				if (ServerResponse.withErrorMessage(result)){
					ServerResponse.handleErrorMessage(result);
				} else {
					this.updateView(result);
					ScreenManager.showScreen("HolidaysDetail");
				}
				ScreenManager.loaderStop();
			} else {
				$.post(strings.baseUrl+"rest/holidays-detail/1.0/?id="+id, 
						ServerRequest.createRequestHeader(), function(result){
					if (ServerResponse.withErrorMessage(result)){
						ServerResponse.handleErrorMessage(result);
					} else {
						Category.updateView(result);
						ScreenManager.showScreen("HolidaysDetail");
					}
				}, "json").fail(function() {
					Tools.showErrorMessage(strings.errorTitle, strings.errorLoadEventDetails);
				}).always(function() {;
					ScreenManager.loaderStop();
				});
			}	
		}

		this.clearView = function(){
			$("#HolidaysDetailTitle").text("");	
			$("#HolidaysDetailSubtitleFederalHolidays").text("");
			$("#HolidaysDetailFederalHolidaysEventListEntries").empty().append( "<li class='tapEvent'>("+strings.noEventsAvailable+")</li>" );
			$("#HolidaysDetailSubtitleSchoolHolidays").text("");		
			$("#HolidaysDetailSchoolHolidaysEventListEntries").empty().append( "<li class='tapEvent'>("+strings.noEventsAvailable+")</li>" );
		}

		this.updateView = function(result){
			if (result != null && (result.response || null) != null){
				var data = result.response;
				var year = "";
				if (data.context && data.context.currentYear){
					year = data.context.currentYear;
				}
				$("#HolidaysDetailTitle").text(data.state+" "+year);
				if (data.federalHolidays){
					$("#HolidaysDetailSubtitleFederalHolidays").show();
					$("#HolidaysDetailSubtitleFederalHolidays").text(strings.federalHolidays);
					$("#HolidaysDetailFederalHolidaysEventList").show();
					var events = (data.federalHolidays || null);
					if (events){
						$("#HolidaysDetailFederalHolidaysEventListEntries").empty();
						$.each(events, function(i, field) {
							var date = field.date;
							var datestring = (date.day) + ". " + date.monthname;
							if (lang == "en"){
								datestring = date.monthname + " " + date.day;
							}
							$("#HolidaysDetailFederalHolidaysEventListEntries").append(
								"<li class='overviewEntry font-size-touchlink tiny-font-size-touchlink' "+
								"style='line-height:1.2;border-color:#8fadd5'><span style='font-size:15px'>"+
								datestring+"<br /></span>"+field.title+"</li>" 
							);
						});
					}
				} else {
					$("#HolidaysDetailSubtitleFederalHolidays").hide();
					$("#HolidaysDetailFederalHolidaysEventList").hide();
				}
				if (data.schoolHolidays){
					try {
						$("#HolidaysDetailSubtitleSchoolHolidays").show();
						$("#HolidaysDetailSubtitleSchoolHolidays").text(strings.schoolHolidays);
						$("#HolidaysDetailSchoolHolidaysEventList").show();
						var events = (data.schoolHolidays || null);
						if (events){
							$("#HolidaysDetailSchoolHolidaysEventListEntries").empty();
						    $.each(events, function(i, field) {
								try {
									var startDate = field.startDate;
									var endDate = field.endDate;
									var datestring = (startDate.day) + ". " + startDate.monthname;
									datestring += " &ndash; "+endDate.day+". "+endDate.monthname;
									if (startDate.year < endDate.year){
										datestring += " "+endDate.year;
									}
									if (lang == "en"){
										datestring  = startDate.monthname + " " + startDate.day + " &ndash; ";
										datestring += endDate.monthname + " "+endDate.day;
										if (startDate.year < endDate.year){
											datestring += ", "+endDate.year;
										}
									}
									$("#HolidaysDetailSchoolHolidaysEventListEntries").append( 
										"<li class='overviewEntry font-size-touchlink tiny-font-size-touchlink' "+
										"style='line-height:1.2;border-color:#8fadd5'><span style='font-size:15px'>"+
										datestring+"<br /></span>"+field.title+"</li>" 
									);
								} catch (err){ alertErr(err); }					    	
							});
						}
					} catch (err){ alertErr(err); }
				} else {
					$("#HolidaysDetailSubtitleSchoolHolidays").hide();
					$("#HolidaysDetailFederalSchoolEventList").hide();
				}
			}
		}

	}
	var HolidayDetail = new HolidayDetailClass;


