var appInfo = {
		version: "0.4.5",
		id: "net.cutecalendar.app",
};

var stringSets = {
	de: {
		baseUrl: "http://api.kleiner-kalender.de/",
		appName: "Kleiner Kalender",
		logo: "logo.gif",
		loadData: "Laden ...",
		navStart: "Start",
		navExit: "Beenden",
		navBack: "Zurück",
		navAbout: "Über diese App",
		navHolidays: "Ferien & Feiertage",
		navSettings: "Einstellungen",
		navDatepicker: "Datumsauswahl",
		navShare: "Teilen",
		navExport: "Event exportieren",
		moreInfo: "Weitere Informationen",
		errorTitle: "Fehler",
		errorLoadCurrentEvents: "Aktuelle Events konnten nicht geladen werden. (Keine Verbindung?)",
		errorLoadDateEvents: "Events konnten nicht geladen werden. (Keine Verbindung?)",
		errorLoadEventDetails: "Detailinfos konnten nicht geladen werden. (Keine Verbindung?)",
		errorCorruptedData: "Unbekannter Fehler beim Laden von Daten.",
		errorNoNetwork: "Keine Netzwerkverbindung - Laden aktueller Daten nicht möglich.",
		errorShareFailed: "Der Dialog zum Teilen konnte nicht geladen werden.",
		errorShareNoData: "Es wurden keine Daten zum Teilen gefunden.",
		errorEventExportFailed: "Der Termin konnte nicht exportiert werden.",
		errorEventExportInavlidData: "Der Termin konnte wegen fehlerhafter Daten nicht exportiert werden.",
		noticeTitle: "Hinweis",
		noEventsAvailable: "Keine Events vorhanden",
		overviewTapToReload: "Hier tippen, um das Laden aktueller Event-Daten nochmals zu versuchen.",
		aboutMoreText: "Weitere Informationen über den Kleinen Kalender gibt es im Internet:",
		aboutUrlHref: "http://www.kleiner-kalender.de/",
		aboutUrlTitle: "www.kleiner-kalender.de",
		aboutUrlFacebook: "https://www.facebook.com/kleinerkalender",
		aboutUrlTwitter: "https://twitter.com/KleinerKalender",
		aboutUrlNewsletter: "http://feed.kleiner-kalender.de/newsletter/",
		aboutUrlInstagram: "https://instagram.com/kleinerkalender",
		aboutUrlDonation: "http://www.kleiner-kalender.de/etc/spende/spenden.html",
		aboutTextDonation: "Spenden",
		noDetailInfo: "Keine Detailinfo vorhanden ...",
		category: "Kategorie",
		infoAboutDay: "Infos zum Datum",
		infoCalendarWeek: "Kalenderwoche",
		infoDayOfTheYear: "Tag des Jahres",
		infoDaysLeft: "Tage bis Jahresende",
		infoWeekday: "Wochentag",
		infoMonth: "Monat",
		infoZodiacSign: "Sternzeichen",
		infoIslamicCalendar: "Islamischer Kalender",
		infoJewishCalendar: "Jüdischer Kalender",
		infoSunPath: "Sonnenstand",
		infoSunrise: "Sonnenaufgang",
		infoSunset: "Sonnenuntergang",
		infoSunForPlace: "Werte für",
		infoQuote: "Kalenderspruch",
		infoNameDays: "Namenstage",
		wordOClock: "Uhr",
		wordToday: "Heute",
		schoolHolidays: "Schulferien",
		federalHolidays: "Gesetzliche Feiertage",
		freeHint: "Diese App ist kostenlos. Wenn sie Dir gefällt, freuen wir uns über eine positive Bewertung im Marketplace.",
		settingsTitle: "Einstellungen",
		settingsSectionEvents: "Zusätzliche Events zeigen",
		settingsSectionLookAndFeel: "Look & Feel",
		settingsTheatricalReleases: "Kinostarts",
		settingsConcertsFestivals: "Konzerte & Festivals",
		settingsFairsCongresses: "Messen & Kongresse",
		settingsFolkFestivals: "Volksfeste",
		settingsNoImages: "Keine Bilder laden",
		settingsNoLoader: "Keine Lade-Animation",
		proHintLabel: "Werbefreie Version",
		proHintUrlAndroid: "https://play.google.com/store/apps/details?id=net.cutecalendar.app.pro",
		proHintUrlIos: "https://itunes.apple.com/us/app/cute-calendar-pro/id1182838505?l=de",
	},
	en: {
		baseUrl: "http://api.cute-calendar.com/",
		appName: "Cute Calendar",
		logo: "logo-en.gif",
		loadData: "Loading ...",
		navStart: "Start",
		navExit: "Exit",
		navBack: "Back",
		navAbout: "About this App",
		navHolidays: "Federal Holidays",
		navSettings: "Settings",
		navDatepicker: "Date picker",
		navShare: "Share",
		navExport: "Export event",
		moreInfo: "More information",
		errorTitle: "Error",
		errorLoadCurrentEvents: "Can't load data for current day. (No connection?)",
		errorLoadDateEvents: "Can't load event data. (No connection?)",
		errorLoadEventDetails: "Can't load event details. (No connection?)",
		errorCorruptedData: "Unknown error while loading data.",
		errorNoNetwork: "No network connection - can't load data.",
		errorShareFailed: "Can't display sharing dialog.",
		errorShareNoData: "Can't load data for sharing.",
		errorEventExportFailed: "Can't export the event.",
		errorEventExportInavlidData: "Can't export the event due to faulty data.",
		noticeTitle: "Notice",
		noEventsAvailable: "No events available",
		overviewTapToReload: "Tap here to try loading again.",
		aboutMoreText: "Find out more information about Cute Calendar online:",
		aboutUrlHref: "http://www.cute-calendar.com/",
		aboutUrlTitle: "www.cute-calendar.com",
		aboutUrlFacebook: "https://www.facebook.com/cutecalendar",
		aboutUrlTwitter: "https://twitter.com/CuteCalendar",
		aboutUrlNewsletter: "http://feed.cute-calendar.com/newsletter/",
		aboutUrlInstagram: "https://instagram.com/cute.calendar",
		aboutUrlDonation: "http://www.cute-calendar.com/etc/donation/donate.html",
		aboutTextDonation: "Donate",
		noDetailInfo: "No details available ...",
		category: "Category",
		infoAboutDay: "About this Date",
		infoCalendarWeek: "calendar week",
		infoDayOfTheYear: "day of the year",
		infoDaysLeft: "days until next year",
		infoWeekday: "Week day",
		infoMonth: "Month",
		infoZodiacSign: "Zodiac sign",
		infoIslamicCalendar: "Islamic Calendar",
		infoJewishCalendar: "Jewish Calendar",
		infoSunPath: "Sun path",
		infoSunrise: "Sunrise",
		infoSunset: "Sunset",
		infoSunForPlace: "Values for",
		infoQuote: "Quote of the day",
		infoNameDays: "Name days",
		wordOClock: "o'clock",
		wordToday: "Today",
		schoolHolidays: "School Holidays",
		federalHolidays: "Federal Holidays",
		freeHint: "This is a free app. If you like it, we would appreciate a positive rating in the marketplace. Donation button under 'About'.",
		settingsTitle: "Settings",
		settingsSectionEvents: "Show additional events",
		settingsSectionLookAndFeel: "Look & Feel",
		settingsTheatricalReleases: "Theatrical releases",
		settingsConcertsFestivals: "Concerts & Festivals",
		settingsFairsCongresses: "Fairs & Congresses",
		settingsFolkFestivals: "Folk  Festivals",
		settingsNoImages: "No images",
		settingsNoLoader: "No loaders",
		proHintLabel: "Ad-free version",
		proHintUrlAndroid: "https://play.google.com/store/apps/details?id=net.cutecalendar.app.pro",
		proHintUrlIos: "https://itunes.apple.com/us/app/cute-calendar-pro/id1182838505?l=en",
	}
	

};
